package com.usky.fire.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.usky.fire.domain.DemEnforceReportAttach;
import com.usky.fire.domain.DemEnforceReportComplaint;
import com.usky.fire.mapper.DemEnforceReportComplaintMapper;
import com.usky.fire.service.DemEnforceReportAttachService;
import com.usky.fire.service.DemEnforceReportComplaintService;
import com.usky.common.mybatis.core.AbstractCrudService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 监督检查举报投诉信息 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-09-23
 */
@Service
public class DemEnforceReportComplaintServiceImpl extends AbstractCrudService<DemEnforceReportComplaintMapper, DemEnforceReportComplaint> implements DemEnforceReportComplaintService {

    @Autowired
    private DemEnforceReportAttachService demEnforceReportAttachService;

    public void enforceReportComplaintList(String serialNumber, String reportPhone, Integer pageNum, Integer pageSize){
        List<Object> list = new ArrayList<>();
        IPage<DemEnforceReportComplaint> page = new Page<>(pageNum, pageSize);
        IPage<DemEnforceReportAttach> page1 = new Page<>(pageNum, pageSize);
        LambdaQueryWrapper<DemEnforceReportComplaint> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.select()
                .eq(DemEnforceReportComplaint::getEnable,0)
                .like(StringUtils.isNotBlank(serialNumber),DemEnforceReportComplaint::getSerialNumber,serialNumber)
                .like(StringUtils.isNotBlank(reportPhone),DemEnforceReportComplaint::getRepeatReport,reportPhone)
                .orderByDesc(DemEnforceReportComplaint::getId);
        page = this.page(page, queryWrapper);
        if (CollectionUtils.isNotEmpty(page.getRecords())){
            List<String> reportIdList = new ArrayList<>();
            for (int i = 0; i < page.getRecords().size(); i++) {
                reportIdList.add(page.getRecords().get(i).getReportId());
            }
            LambdaQueryWrapper<DemEnforceReportAttach> queryWrapper1 = Wrappers.lambdaQuery();
            queryWrapper1.select()
                    .in(DemEnforceReportAttach::getReportId,reportIdList);
            page1=demEnforceReportAttachService.page(page1, queryWrapper1);

        }
    }
}
